clc;
clear;
k = 100;
% Perform feature selection
% load data
data=dlmread('HillValley.data',' ',1,0);
d=data(:,2:end);
f=data(:,1);
featureL = size(d,2);
if k > featureL
    k = featureL
end
opts.k = 5; 
opts.N  = 50;     % number of solutions
opts.T  = 100;    % maximum number of iterations
opts.tf = 1;
% Parameters of PSO
opts.c1 = 2;
opts.c2 = 2;
opts.w  = 0.9;

ho = 0.2;
HO = cvpartition(f,'HoldOut',ho); 
opts.Model = HO;

X_train = d(HO.training,:);
Y_train = f(HO.training);
X_test = d(HO.test,:);
Y_test = f(HO.test); 

[feq_miq_mine] = mrmr_miq_d_mine(X_train,Y_train);
feat=X_train(:,feq_miq_mine(1:k));

FS = ParticleSwarmOptimization(d(:,feq_miq_mine(1:k)),f,opts);
sf_idx = FS.sf;

res_pso = 0;
model = svmtrain(Y_train, X_train(:,feq_miq_mine(sf_idx)));
[predicted_label, accuracy, prob_estimates] = svmpredict(Y_test, X_test(:,feq_miq_mine(sf_idx)), model);
res_pso = accuracy

model = svmtrain(Y_train, X_train(:,feq_miq_mine(1:length(sf_idx))));
[predicted_label, accuracy, prob_estimates] = svmpredict(Y_test, X_test(:,feq_miq_mine(1:length(sf_idx))), model);
res_mrmr=accuracy

ops.fl = length(sf_idx);
res_other = testOtherFSAlgorithms(X_train,Y_train,X_test,Y_test,ops);
res_other